#import <Foundation/Foundation.h>

#define MORE_PARAMETERS   1

@interface Foo : NSObject
{
}

- (NSString *) a:(int) a
               b:(double) b
               c:(long long) c
               d:(float) d

               e:(NSNumber *) e
               f:(double) f
               g:(int) g
               h:(int) h
#if MORE_PARAMETERS
               i:(int) i
               j:(int) j
               k:(int) k
               l:(long) l

               m:(int) m
               n:(int) n
               o:(int) o
               p:(double) p
#endif
   ;

@end

@implementation Foo

- (NSString *) a:(int) a
               b:(double) b
               c:(long long) c
               d:(float) d

               e:(NSNumber *) e
               f:(double) f
               g:(int) g
               h:(int) h
#if MORE_PARAMETERS

               i:(int) i
               j:(int) j
               k:(int) k
               l:(long) l

               m:(int) m
               n:(int) n
               o:(int) o
               p:(double) p
#endif
{
   NSString  *s;
   
   s = [NSString stringWithFormat:@"abcd=%d %.1f %qd %.1f  efgh=%@ %.1f %d %d",
      a, b, c, d, 
      e, f, g, h];
   
#if MORE_PARAMETERS
   s = [s stringByAppendingFormat:@" ijkl=%d %d %d %ld  mnop=%ld %d %d %.1f", 
      i, j, k, l,
      m, n, o, p];
#endif   
   return( s);
}

@end

#if GNUSTEP_BASE_LIBRARY
enum _NSObjCValueType {
    NSObjCNoType = 0,
    NSObjCVoidType = 'v',
    NSObjCCharType = 'c',
    NSObjCShortType = 's',
    NSObjCLongType = 'l',
    NSObjCLonglongType = 'q',
    NSObjCFloatType = 'f',
    NSObjCDoubleType = 'd',
#if 0
    NSObjCBoolType = 'B',
#endif
    NSObjCSelectorType = ':',
    NSObjCObjectType = '@',
    NSObjCStructType = '{',
    NSObjCPointerType = '^',
    NSObjCStringType = '*',
    NSObjCArrayType = '[',
    NSObjCUnionType = '(',
    NSObjCBitfield = 'b'
};

typedef struct {
    enum _NSObjCValueType type;
    union {
    	char charValue;
	short shortValue;
	long longValue;
	long long longlongValue;
	float floatValue;
	double doubleValue;
#if 0
	bool boolValue;
#endif
	SEL selectorValue;
	id objectValue;
	void *pointerValue;
	void *structLocation;
	char *cStringLocation;
    } value;
} NSObjCValue;

#endif

static void   dump_invocation( NSInvocation *invocation)
{
   unsigned int        i, n;
   NSMethodSignature   *signature;
   char                *type;
   NSObjCValue         buf;
   
   signature = [invocation methodSignature];
   
   n = [signature numberOfArguments];
   for( i = 0; i < n; i++)
   {
      printf( "%u : ", i);
      type = [signature getArgumentTypeAtIndex:i];
      [invocation getArgument:&buf.value
                      atIndex:i];
      switch( *type)
      {
      case ':' : printf( [NSStringFromSelector( buf.value.selectorValue) cString]); break;
         
      default  : printf( "%d", buf.value.longValue); break;
      case 'l' : printf( "%ld", buf.value.longValue); break;
      case 'L' : printf( "%lu", buf.value.longValue); break;
      case 'q' : printf( "%qd", buf.value.longlongValue); break;
      case 'Q' : printf( "%qu", buf.value.longlongValue); break;
         // float does not get promoted to double (on PPC) apparently
      case 'f' : printf( "%f", buf.value.floatValue); break;
      case 'd' : printf( "%f", buf.value.doubleValue); break;
      case '@' : printf( [[buf.value.objectValue description] cString]); break;
      case '*' : printf( "\"%s\"", buf.value.cStringLocation); break;
      case '^' : printf( "%p", buf.value.pointerValue); break;
      case '[' :
      case '}' :
      case '(' :
            [NSException raise:NSInvalidArgumentException
                        format:@"Can't deal with union/struct/array parameters"];
      }        
      printf( "\n");
   }
}


int main (int argc, const char * argv[]) 
{
    NSAutoreleasePool * pool = [[NSAutoreleasePool alloc] init];
   
   NSMethodSignature   *signature;
   NSInvocation        *invocation;
   id                  rval;
   Foo                 *foo;
   NSString            *s1;
   NSString            *s2;
   SEL                 sel;
   
   int          a = 1;
   double       b = 2.0;
   long long    c = 3LL;
   float        d = 4.0;
   NSNumber    *e = [NSNumber numberWithUnsignedInt:5];
   double       f = 6.0;
   int          g = 7;
   int          h = 8;
#if MORE_PARAMETERS
   int          i = 9;
   int          j = 10;
   int          k = 11;
   long         l = 12;
   int          m = 13;
   int          n = 14;
   int          o = 15;
   double       p = 16.0;
#endif
   
   foo = [[Foo new] autorelease];
   
#if MORE_PARAMETERS
   sel = @selector( a:b:c:d:e:f:g:h:i:j:k:l:m:n:o:p:);
#else
   sel = @selector( a:b:c:d:e:f:g:h:);
#endif
   
   signature = [foo methodSignatureForSelector:sel];
   invocation = [NSInvocation invocationWithMethodSignature:signature];

   [invocation setTarget:foo];
   [invocation setSelector:sel];

   s1 = [foo a:a 
             b:b
             c:c
             d:d
             e:e
             f:f
             g:g
             h:h
#if MORE_PARAMETERS
             i:i
             j:j
             k:k
             l:l
             m:m
             n:n
             o:o
             p:p
#endif
      ];

   [invocation setArgument:&a
                   atIndex:2];
   [invocation setArgument:&b
                   atIndex:3];
   [invocation setArgument:&c
                   atIndex:4];
   [invocation setArgument:&d
                   atIndex:5];
   [invocation setArgument:&e
                   atIndex:6];
   [invocation setArgument:&f
                   atIndex:7];
   [invocation setArgument:&g
                   atIndex:8];
   [invocation setArgument:&h
                   atIndex:9];
#if MORE_PARAMETERS
   [invocation setArgument:&i
                   atIndex:10];
   [invocation setArgument:&j
                   atIndex:11];
   [invocation setArgument:&k
                   atIndex:12];
   [invocation setArgument:&l
                   atIndex:13];
   [invocation setArgument:&m
                   atIndex:14];
   [invocation setArgument:&n
                   atIndex:15];
   [invocation setArgument:&o
                   atIndex:16];
   [invocation setArgument:&p
                   atIndex:17];
#endif   
   dump_invocation( invocation);
   
   [invocation invoke];
   
   [invocation getReturnValue:&rval];
   
   NSLog( @"%s", [s1 isEqualToString:rval] ? "SUCCESS" : "FAILURE");
   NSLog( @"Got      : %@", rval);
   NSLog( @"Expected : %@", s1);
      
   s2 = [foo a:a 
             b:b
             c:c
             d:d
             e:e
             f:f
             g:g
             h:h
#if MORE_PARAMETERS
             i:i
             j:j
             k:k
             l:l
             m:m
             n:n
             o:o
             p:p
#endif      
      ];

   if( ! [s1 isEqualToString:s2])
      NSLog( @"INVOCATION MANGLED OUR LOCAL VARIABLES\nNow      : %@",  s2);
   
   [pool release];
   return 0;
}
